# MySQL dump 8.16
#
# Host: localhost    Database: phpmyezin
#--------------------------------------------------------
# Server version	3.23.47-log

#
# Table structure for table 'ezin_articles'
#

DROP TABLE IF EXISTS ezin_articles;
CREATE TABLE ezin_articles (
  id int(11) NOT NULL auto_increment,
  author_id int(11) default NULL,
  section_id int(11) default NULL,
  bind_lang int(11) default NULL,
  bind_theme int(11) default NULL,
  accesses_count int(11) default NULL,
  sessions_count int(11) default NULL,
  message_count int(11) default NULL,
  status enum('showed','partly_showed','hidden','disabled') default NULL,
  datetime datetime default '0000-00-00 00:00:00',
  hometext_flags varchar(10) default NULL,
  bodytext_flags varchar(10) default NULL,
  access_key varchar(32) default NULL,
  template_key varchar(32) default NULL,
  title varchar(255) default NULL,
  atitle varchar(255) default NULL,
  hometext text,
  bodytext text,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_authors'
#

DROP TABLE IF EXISTS ezin_authors;
CREATE TABLE ezin_authors (
  id int(10) NOT NULL auto_increment,
  name varchar(60) default NULL,
  email varchar(60) default NULL,
  homepage varchar(150) default NULL,
  description text,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_cache'
#

DROP TABLE IF EXISTS ezin_cache;
CREATE TABLE ezin_cache (
  id varchar(8) binary NOT NULL default '0',
  timestamp int(11) default NULL,
  var_var int(1) default NULL,
  content longblob,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_config'
#

DROP TABLE IF EXISTS ezin_config;
CREATE TABLE ezin_config (
  a_key varchar(32) NOT NULL default '',
  type int(2) default NULL,
  value text,
  PRIMARY KEY  (a_key)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_config_info'
#

DROP TABLE IF EXISTS ezin_config_info;
CREATE TABLE ezin_config_info (
  a_key varchar(32) NOT NULL default '',
  ord int(11) default NULL,
  name varchar(255) default NULL,
  description text,
  PRIMARY KEY  (a_key)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_counts_temp'
#

DROP TABLE IF EXISTS ezin_counts_temp;
CREATE TABLE ezin_counts_temp (
  type_id char(8) binary default NULL,
  timestamp int(11) default NULL,
  ip char(32) default NULL,
  KEY type_id (type_id),
  KEY ip (ip)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_editorials'
#

DROP TABLE IF EXISTS ezin_editorials;
CREATE TABLE ezin_editorials (
  id int(10) NOT NULL auto_increment,
  section_id int(10) default NULL,
  datetime datetime default NULL,
  text_flags varchar(10) default NULL,
  text text,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_feedback_data'
#

DROP TABLE IF EXISTS ezin_feedback_data;
CREATE TABLE ezin_feedback_data (
  feedback_id int(11) NOT NULL default '0',
  field varchar(255) default NULL,
  data text,
  KEY feedback_id (feedback_id),
  KEY field (field)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_feedbacks'
#

DROP TABLE IF EXISTS ezin_feedbacks;
CREATE TABLE ezin_feedbacks (
  id int(11) NOT NULL auto_increment,
  section_id int(11) NOT NULL default '0',
  datetime datetime default NULL,
  ip varchar(255) default NULL,
  user_agent varchar(255) default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_messages'
#

DROP TABLE IF EXISTS ezin_messages;
CREATE TABLE ezin_messages (
  id bigint(20) NOT NULL auto_increment,
  parent int(10) default NULL,
  article_id int(10) default NULL,
  author varchar(255) default NULL,
  email varchar(255) default NULL,
  homepage varchar(255) default NULL,
  subject varchar(255) default NULL,
  message text,
  datetime datetime default NULL,
  ip varchar(255) default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_roles'
#

DROP TABLE IF EXISTS ezin_roles;
CREATE TABLE ezin_roles (
  id int(10) NOT NULL auto_increment,
  name varchar(60) default NULL,
  login varchar(10) default NULL,
  articles varchar(10) default NULL,
  authors varchar(10) default NULL,
  sections varchar(10) default NULL,
  editorials varchar(10) default NULL,
  messages varchar(10) default NULL,
  feedbacks varchar(10) default NULL,
  sessions varchar(10) default NULL,
  config varchar(10) default NULL,
  users varchar(10) default NULL,
  roles varchar(10) default NULL,
  file_management varchar(15) default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_sections'
#

DROP TABLE IF EXISTS ezin_sections;
CREATE TABLE ezin_sections (
  id int(10) NOT NULL auto_increment,
  author_id int(10) default NULL,
  type enum('global','normal','hidden','hidden2','full_hidden','disabled') default NULL,
  lang char(2) default NULL,
  bind_lang int(11) default NULL,
  ord int(10) default '100',
  a_limit int(10) default NULL,
  accesses_count int(11) default NULL,
  sessions_count int(11) default NULL,
  raw_accesses_count int(11) default NULL,
  raw_sessions_count int(11) default NULL,
  access_key varchar(32) default NULL,
  template_key varchar(32) default NULL,
  name varchar(60) default NULL,
  link varchar(255) default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_sessions'
#

DROP TABLE IF EXISTS ezin_sessions;
CREATE TABLE ezin_sessions (
  id int(11) NOT NULL auto_increment,
  session_id int(11) default NULL,
  username varchar(255) default NULL,
  password varchar(255) default NULL,
  login datetime default NULL,
  logout datetime default NULL,
  status varchar(16) default NULL,
  ip varchar(64) default NULL,
  user_agent varchar(255) default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'ezin_users'
#

DROP TABLE IF EXISTS ezin_users;
CREATE TABLE ezin_users (
  id int(10) NOT NULL auto_increment,
  username varchar(60) default NULL,
  password varchar(60) default NULL,
  author_id int(11) default NULL,
  role_id int(11) default NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY username (username)
) TYPE=MyISAM;

# MySQL dump 8.16
#
# Host: localhost    Database: phpmyezin
#--------------------------------------------------------
# Server version	3.23.47-log

#
# Dumping data for table 'ezin_roles'
#

INSERT INTO ezin_roles VALUES (1,'0 - superuser','1','LFACPDV','LFACPDV','LFACPDV','LFACPDV','LFACPDV','LC','l','LC','LFACPDV','LFACPDV','LRDCErdcuves');
INSERT INTO ezin_roles VALUES (2,'1 - admin','1','LFACV','LFACV','LFACV','LFACV','LCV',NULL,'',NULL,'l','LV','LRCErvu');
INSERT INTO ezin_roles VALUES (3,'5 - editor','1','LFACV','LFV','LV','LV','LV',NULL,'',NULL,'l','LV','LRCErvu');
INSERT INTO ezin_roles VALUES (4,'6 - author','1','','LFc','','','',NULL,'',NULL,'','','');
INSERT INTO ezin_roles VALUES (5,'9 - enemy','0','','','','','',NULL,'','','','','');
INSERT INTO ezin_roles VALUES (6,'8 - nobody','1','','','','','',NULL,'',NULL,'','','');
INSERT INTO ezin_roles VALUES (7,'3 - advanced editor','1','LFACV','LFACV','LV','LV','LV',NULL,'',NULL,'l','LV','LRCErvu');
INSERT INTO ezin_roles VALUES (8,'7 - visitor','1','LFV','LFV','LFV','LFV','LFV',NULL,'l','L','lFV','LFV','LEv');

--
-- Default users
--
INSERT INTO ezin_users VALUES (1,'admin','896ae34257056a6edb7643e3db85bb21',0,1);
INSERT INTO ezin_users VALUES (2,'user', '896ae34257056a6edb7643e3db85bb21',0,3);

--
-- Default authors
--
INSERT INTO ezin_authors (id, name, email, homepage, description) VALUES
	(1,'Admin','platon@platon.sk','http://platon.sk/','This is Admin.');
INSERT INTO ezin_authors (id, name, email, homepage, description) VALUES
	(2,'Ondrej Jombk','nepto@platon.sk','http://nepto.sk/','This is Nepto. ;-)');

--
-- Default section
--
INSERT INTO ezin_sections
	(id, author_id, type, ord, a_limit,
	accesses_count, sessions_count, raw_accesses_count, raw_sessions_count,
	access_key, template_key, name, link)
VALUES
	(1,0,'global',100,10,
	NULL,NULL,NULL,NULL,
	'index','','Index','');
--
-- Default article
--
INSERT INTO ezin_articles
	(id, author_id, section_id,
	accesses_count, sessions_count, message_count,
	status, datetime, access_key, template_key,
	title, atitle, hometext, bodytext)
VALUES (1,2,1,
	NULL,NULL,NULL,
	'showed','2002-09-13 16:23:00','','',
	'Default article title','Default article annotation title',
	'Default article home text (annotation)',
	'Default article body text');

