<?php

// Authentification

if (@file_exists('inc/auth.inc.php') && @include_once 'inc/auth.inc.php');
else exit;

// General options

$ezin_opts['hn'] = $ezin_sys['db']['host'];
$ezin_opts['un'] = $ezin_sys['db']['user'];
$ezin_opts['pw'] = $ezin_sys['db']['pass'];
$ezin_opts['db'] = $ezin_sys['db']['name'];
$ezin_opts['tb'] = $ezin_sys['db']['tables']['authors'];
$ezin_opts['key'] = 'id';
$ezin_opts['key_type'] = 'int';
$ezin_opts['sort_field'] = 'id';
$ezin_opts['inc'] = 20;
$ezin_opts['options'] = $ezin_USER['role_authors'];
$ezin_opts['multiple'] = '4';
$ezin_opts['navigation'] = $ezin_cfg['admin_navigation'].$ezin_cfg['admin_buttons_pos'];
$ezin_opts['display'] = array('query' => false, 'sort'  => false, 'time'  => false);
$ezin_opts['url'] = array('images' => 'icons/');
$ezin_opts['sort_field'] = '-id';
$ezin_opts['language'] = 'EN';

// Triggers

$ezin_opts['triggers']['update']['after'] = 'inc-db/triggers/authors.after';
$ezin_opts['triggers']['delete']['after'] = 'inc-db/triggers/authors.after';

// Field definitions

$ezin_opts['fdd']['id'] = array(
		'name'=>'ID',
		'select'=>'T',
		'maxlen'=>3,
		'sort'=>true,
		'default'=>'',
		'options'=>'LDVFPCR',
		);

$ezin_opts['fdd']['name'] = array(
		'name'=>'Name',
		'select'=>'T',
		'maxlen'=>60,
		'sort'=>true,
		'required'=>true
		);

$ezin_opts['fdd']['email'] = array(
		'name'=>'E-mail',
		'select'=>'T',
		'maxlen'=>60,
		'sort'=>true,
		'URLprefix'=>'mailto:',
		'URLtarget'=>'_blank'
		);

$ezin_opts['fdd']['homepage'] = array(
		'name'=>'Homepage',
		'select'=>'T',
		'maxlen'=>60,
		'sort'=>true,
		'URLprefix'=>array('http://', 'https://', 'ftp://'),
		'URLtarget'=>'_blank'
		);

$ezin_opts['fdd']['description'] = array(
		'name'=>'Description',
		'select'=>'T',
		'textarea'=>array(
			'rows'=>5,
			'cols'=>65,
			),
		'sort'=>true,
		'options'=>'ACPV'
		);

// Execution code

if (! ezin_admin_check_list_privileges($ezin_opts['options'])) {
	require 'inc-html/permdenied.html';
} else {
	/* if (! ezin_admin_check_privileges($ezin_opts['options'],
	   $rec == $ezin_USER['author_id'])) {
	   require 'inc-html/permdenied.html';
	   } */

	require_once 'phpMyEdit/phpMyEdit.class.php';
	new phpMyEdit($ezin_opts);
}

?>
