<?php

if (@file_exists('inc/auth.inc.php') && @include_once 'inc/auth.inc.php');
else exit;

require_once 'db-core/db-core.inc.php';

/*
 * ezin_admin_config_main()
 */

function ezin_admin_feedbacks_main($restricted = 0) /* {{{ */
{
	$feedback_id = Platon::get_cgi_var('id', '');
	if ($feedback_id != '') {
		$delete = Platon::get_cgi_var('delete', '');
		$cancel = Platon::get_cgi_var('cancel', '');
		if (strlen($cancel) > 0) {
		} else if (strlen($delete) > 0 && is_array($feedback_id) && ! $restricted) {
			ezin_admin_feedbacks_delete($feedback_id);
		} else if (! is_array($feedback_id)) {
			$feedback_id = intval($feedback_id);
			if ($feedback_id > 0) {
				return ezin_admin_feedbacks_view($restricted, $feedback_id);
			}
		}
	}
	return ezin_admin_feedbacks_list($restricted);
} /* }}} */

function ezin_admin_feedbacks_delete($ar) /* {{{ */
{
	global $ezin_cfg;
	global $ezin_sys;
	global $ezin_db_handle;

	foreach ($ar as $feedback_id) {
		$feedback_id = intval($feedback_id);
		if ($feedback_id <= 0) {
			continue;
		}
		$query  = sprintf('DELETE FROM %s WHERE feedback_id = %d',
				$ezin_sys['db']['tables']['feedback_data'], $feedback_id);
		@mysql_query($query, $ezin_db_handle);
		$query  = sprintf('DELETE FROM %s WHERE id = %d',
				$ezin_sys['db']['tables']['feedbacks'], $feedback_id);
		@mysql_query($query, $ezin_db_handle);
	}
	return true;
} /* }}} */

function ezin_admin_feedbacks_view($restricted, $feedback_id) /* {{{ */
{
	global $ezin_cfg;
	global $ezin_sys;
	global $ezin_db_handle;

	$query = sprintf('SELECT'
			.' f.id, f.section_id, s.access_key AS section_key, f.datetime, f.ip, f.user_agent'
			.' FROM %s AS f LEFT JOIN %s AS s ON f.section_id = s.id'
			.' WHERE f.id = %d',
			$ezin_sys['db']['tables']['feedbacks'],
			$ezin_sys['db']['tables']['sections'],
			$feedback_id);
	$result = @mysql_query($query, $ezin_db_handle);
	if ($result == false) {
		ezin_db_error('ezin_admin_feedbacks_view() [1]');
		return false;
	}
	$feedback = @mysql_fetch_array($result, MYSQL_ASSOC);
	@mysql_free_result($result);
	
	$query  = sprintf('SELECT * FROM %s WHERE feedback_id = %d',
			$ezin_sys['db']['tables']['feedback_data'], $feedback_id);
	$result = @mysql_query($query, $ezin_db_handle);
	if ($result == false) {
		ezin_db_error('ezin_admin_feedbacks_view() [2]');
		return false;
	}
	$feedback_data = array();
	while (($row = @mysql_fetch_array($result, MYSQL_ASSOC)) != false) {
		$feedback_data[$row['field']] = $row['data'];
	}
	@mysql_free_result($result);

	$limit = Platon::get_cgi_var('limit', '');

	echo '<form class="pme-form" method="post">',"\n";
	echo '<input type="hidden" value="'.$feedback_id.'" name="id[]">'."\n";
	echo '<input type="hidden" value="'.$limit.'" name=limit>'."\n";
	if (stristr($ezin_cfg['admin_buttons_pos'], 'U')) {
		ezin_admin_feedbacks_view_button($restricted);
		echo '<hr class="pme-hr">',"\n";
	}

	if (intval(@$feedback['section_id']) > 0) {
		$section_data = intval(@$feedback['section_id']);
		if (strlen(@$feedback['section_key']) > 0) {
			$section_data .= sprintf(' (%s)', htmlspecialchars(@$feedback['section_key']));
		}
	} else {
		$section_data = '<i>unknown</i>';
	}
	$ip_address = '<a target=_blank href="http://'.$feedback['ip'].'/">'.$feedback['ip'].'</a>';
?>
<table class="pme-main">
	<tr class="pme-header"><th class="pme-header" colspan="2">System data</th></tr>
	<tr class="pme-row-0">
		<td class="pme-key-0">ID</td>
		<td class="pme-value-0"><?php echo $feedback['id'] ?></td>
	</tr>
	<tr class="pme-row-1">
		<td class="pme-key-1">Section</td>
		<td class="pme-value-1"><?php echo $section_data ?></td>
	</tr>
	<tr class="pme-row-0">
		<td class="pme-key-0">Date&nbsp;&amp;&nbsp;Time</td>
		<td class="pme-value-0"><?php echo $feedback['datetime'] ?></td>
	</tr>
	<tr class="pme-row-1">
		<td class="pme-key-1">IP</td>
		<td class="pme-value-1"><?php echo $ip_address ?></td>
	</tr>
	<tr class="pme-row-0">
		<td class="pme-key-0">User Agent</td>
		<td class="pme-value-0"><?php echo $feedback['user_agent'] ?></td>
	</tr>
	<tr class="pme-header"><th class="pme-header" colspan="2">Form data</th></tr>
<?php
	$i = 0;
	foreach ($feedback_data as $key => $val) {
		$val = strlen(@$val) > 0 ? nl2br(htmlspecialchars($val)) : '&nbsp;';
		$key = htmlspecialchars($key);
		printf('<tr class="pme-row-%d"><td class="pme-key-%d">%s</td><td class="pme-value-%d">%s</td></tr>',
				$i, $i, $key, $i, $val);
		$i++;
		$i &= 1;
	}
?>
</table>
<?php
	
	if (stristr($ezin_cfg['admin_buttons_pos'], 'D')
			|| ! stristr($ezin_cfg['admin_buttons_pos'], 'U')) {
		echo '<hr class="pme-hr">',"\n";
		ezin_admin_feedbacks_view_button($restricted);
	}
} /* }}} */

function ezin_admin_feedbacks_list($restricted) /* {{{ */
{
	global $ezin_cfg;
	global $ezin_sys;
	global $ezin_db_handle;

	$refresh_up   = Platon::get_cgi_var('refresh_up');
	$refresh_down = Platon::get_cgi_var('refresh_down');

	if (isset($refresh_up)) {
		$limit = Platon::get_cgi_var('limit_up');
	} elseif (isset($refresh_down)) {
		$limit = Platon::get_cgi_var('limit_down');
	} else {
		$limit = Platon::get_cgi_var('limit');
	}

	if (! isset($limit)) {
		$limit = 15;
	} else {
		$limit = intval($limit);
	}

	echo '<form class="pme-form" method="post">',"\n";

	if (stristr($ezin_cfg['admin_buttons_pos'], 'U')) {
		ezin_admin_feedbacks_limit_field($limit, 'up');
		echo '<hr class="pme-hr">',"\n";
	}

	/*
	 * Database query for getting feedbacks
	 */
	$query = sprintf('SELECT'
			.' f.id, f.section_id, s.access_key AS section_key, f.datetime, f.ip, f.user_agent'
			.' FROM %s AS f LEFT JOIN %s AS s ON f.section_id = s.id'
			.' ORDER BY f.datetime DESC, id DESC',
			$ezin_sys['db']['tables']['feedbacks'],
			$ezin_sys['db']['tables']['sections']);

	if (intval($limit) > 0)
		$query .= ' LIMIT ' . intval($limit);

	//echo "$query<hr>";

	$result = @mysql_query($query, $ezin_db_handle);
	if ($result == false) {
		ezin_db_error('ezin_admin_feedbacks_list()');
		return false;
	}

	echo '<table class="pme-main">',"\n";

	if (mysql_num_rows($result) == 0) {
		echo '<tr><td>No feedbacks in database.</td></tr>';
	} else {
?>
<tr class="pme-header">
	<th class="pme-header"<?php echo $restricted ? '' : ' colspan=2' ?>>ID</th>
	<th class="pme-header">Section</th>
	<th class="pme-header">Date &amp; Time</th>
	<th class="pme-header">IP</th>
	<th class="pme-header">User Agent</th>
</tr>
<?php
	}

	$count   = 0;
	$tr_data = array('<tr class="pme-row-0">', '<tr class="pme-row-1">');

	while (($row = @mysql_fetch_array($result, MYSQL_ASSOC)) != false) {
		if (intval(@$row['section_id']) > 0) {
			$section_data = intval(@$row['section_id']);
			if (strlen(@$row['section_key']) > 0) {
				$section_data .= sprintf(' (%s)', htmlspecialchars(@$row['section_key']));
			}
		} else {
			$section_data = '<i>unknown</i>';
		}
		$ip_address = '<a target="_blank" href="http://'.$row['ip'].'/">'.$row['ip'].'</a>';
		echo $tr_data[$count & 1];
		$td_nav  = sprintf('<td class="pme-navigation-%d">'."\n", $count & 1);
		$td_cell = sprintf('<td class="pme-cell-%d">'      ."\n", $count & 1);
		if (! $restricted) {
			echo $td_nav,"\n";
			echo '<input type="checkbox" name="id[]" value="',$row['id'],'">';
			echo '</td>';
		}
		printf($td_nav.'&nbsp;[&nbsp;<a href="%s?id=%d&amp;limit=%d">%03d</a>&nbsp;]&nbsp;</td>'
				.$td_cell.'%s</td>'.$td_cell.'%s</td>'.$td_cell.'%s</td>'.$td_cell.'%s</td>',
				$_SERVER['PHP_SELF'], $row['id'], $limit, $row['id'],
				$section_data, $row['datetime'], $ip_address, $row['user_agent']);
		echo "</tr>\n";
		$count++;
	}

	echo '</table>',"\n";
	
	@mysql_free_result($result);

	if (stristr($ezin_cfg['admin_buttons_pos'], 'D')
			|| ! stristr($ezin_cfg['admin_buttons_pos'], 'U')) {
		echo '<hr class="pme-hr">',"\n";
		ezin_admin_feedbacks_limit_field($limit, 'down');
	}
	echo '</form>',"\n";

	return true;
} /* }}} */

function ezin_admin_feedbacks_limit_field($limit, $pos) /* {{{ */
{
	$text_name = "limit_$pos";
	$refresh_submit_name = "refresh_$pos";
	echo '<table class="pme-navigation">',"\n";
	echo '<tr class="pme-navigation"><td class="pme-buttons">',"\n";
	echo '<input class="pme-refresh" type="submit" name="',$refresh_submit_name,'" value="Refresh">',"\n";
	echo '<input class="pme-delete-checked" type="submit" name="delete" value="Delete checked">',"\n";
	echo '</td>',"\n",'<td class="pme-buttons2">',"\n";
	echo 'Rows count (0 = unlimited):';
	echo ' <input type="text" size="2" name="',$text_name,'" value="',$limit,'">&nbsp;';
	echo '</td></tr></table>',"\n";
} /* }}} */

function ezin_admin_feedbacks_view_button($restricted) /* {{{ */
{
	echo '<table class="pme-navigation">',"\n";
	echo '<tr class="pme-navigation"><td class="pme-buttons">',"\n";
	if (! $restricted) {
		echo '<input class="pme-delete" type="submit" name="delete" value="Delete">',"\n";
	}
	echo '<input class="pme-cancel" type="submit" name="cancel" value="Cancel">',"\n";
	echo '</td></tr></table>',"\n";
} /* }}} */

/*
 * Main stuff
 */

if (strstr($ezin_USER['role_feedbacks'], 'C')) {
	ezin_check_db_handle();
	ezin_admin_feedbacks_main(0);
	ezin_close_db_connection();
} elseif (ezin_admin_check_list_privileges($ezin_USER['role_feedbacks'])) {
	ezin_check_db_handle();
	ezin_admin_feedbacks_main(1);
	ezin_close_db_connection();
}

/* Modeline for ViM {{{
 * vim: set ts=4:
 * vim600: fdm=marker fdl=0 fdc=0:
 * }}} */

?>
