<?php

/*
 * phpMyEzin - e-zin content management system
 *
 * config/loader.inc.php - configuration loader and initializer
 * ____________________________________________________________
 *
 * Developed by Ondrej Jombik <nepto@platon.sk>
 * Copyright (c) 2001-2004 Platon SDG, http://platon.sk/
 * All rights reserved.
 *
 * See README file for more information about this software.
 * See COPYING file for license information.
 *
 * Download the latest version from
 * http://platon.sk/projects/phpMyEzin/
 */

/* $Platon: $ */

/*
 * WARNING! Do not edit this file! Edit db-config.inc.php file in this directory!
 */

/*
 * Error reporting, magic quotes, etc.
 */
error_reporting(E_ALL);
set_magic_quotes_runtime(0);

/*
 * Directory configuration
 */

$ezin_sys = array( /* {{{ */
		'dir' => array(
			'root'   => getcwd(),
			'admin'  => 'admin',
			'themes' => 'themes',
			'upload' => 'upload'
			)); /* }}} */

/*
 * Include path stuff
 */

ini_set('include_path', join( /* ... ) {{{ */
			strncmp(php_uname(), 'Windows', 7) ? ':' : ';',
			array('.', $ezin_sys['dir']['root'] . '/lib/',
			/*	$ezin_sys['dir']['root'] . '/lib/PEAR/',
				$ezin_sys['dir']['root'] . '/lib/phpMyEdit/',
				$ezin_sys['dir']['root'] . '/lib/db-core/' */)
			)); 

if (! strncmp(php_uname(), 'Windows', 7)) {
	ini_set('include_path', str_replace('/', '\\', ini_get('include_path')));
} /* }}} */

/*
 * Basic inclusion and timer initialization
 */

@require_once 'Platon.php';
$ezin_sys['time']['start'] = Platon::get_mtime();

/*
 * Database connection constants
 */

$ezin_db_config_file = dirname(__FILE__)
	. (strlen(dirname(__FILE__)) > 0 ? '/' : '')
	. 'db-config.inc.php';

	if (! @file_exists($ezin_db_config_file)) {
		exit;
	}

require_once $ezin_db_config_file;

/*
 * Table constats
 */

$ezin_sys['db']['tables'] = array( /* {{{ */
		'authors'       => 'ezin_authors',
		'articles'      => 'ezin_articles',
		'sections'      => 'ezin_sections',
		'editorials'    => 'ezin_editorials',
		'messages'      => 'ezin_messages',
		'sessions'      => 'ezin_sessions',
		'config_data'   => 'ezin_config',
		'config_info'   => 'ezin_config_info',
		'users'         => 'ezin_users',
		'roles'         => 'ezin_roles',
		'counts_temp'   => 'ezin_counts_temp',
		'feedbacks'     => 'ezin_feedbacks',
		'feedback_data' => 'ezin_feedback_data',
		'cache'         => 'ezin_cache'
		); /* }}} */

/*
 * Template engine configuration
 */

$ezin_sys['tmpl'] = array( /* {{{ */
		// Templates functions issues
		'fnc_file'   => 'functions.php',
		'fnc_prefix' => 'ezin_tmpl_',
		// Template deliminator and file extension
		'delim'      => '.',
		'ext'        => 'tmpl',
		'delimext'   => '.tmpl', ### sync this with two above ###
		// Main templates
		'error'           => 'error',
		'notfound'        => 'notfound',
		'admin'           => 'admin',
		'section'         => 'section',
		'article'         => 'article',
		'article_print'   => 'article_print',
		'message'         => 'message',
		'message_edit'    => 'message_edit',
		// Item templates
		'article_item'      => 'article_item',
		'section_item'      => 'section_item',
		'message_item'      => 'message_item',
		'message_full_item' => 'message_full_item',
		// E-mail templates
		'e-mail' => array(
				'error'    => 'e-mail-error',
				'feedback' => 'e-mail-feedback',
				)
); /* }}} */

/*
 * File create & upload constants
 *
 * $ezin_sys['mode']['dir'] must be set; set $ezin_sys['mode']['file'] to 0
 * if you want to create it with default premissions
 */

$ezin_sys['mode'] = array( /* {{{ */
		'file' => 0,
		'dir'  => 0777
		); /* }}} */

/*
 * Software information
 */

$ezin_sys['software'] = array( /* {{{ */
		'name'      => 'phpMyEzin',
		'version'   => '0.8.3 (development)',
		'signature' => '<b>phpMyEzin</b> - GNU/GPL content management system<br>'
		.' (development alpha pre-release)',
		'url'       => 'http://platon.sk/projects/phpMyEzin/'
		); /* }}} */

/*
 * Auth options
 */

$ezin_sys['db']['dsn'] = 'mysql://'.$ezin_sys['db']['user'].':'.$ezin_sys['db']['pass']
.'@'.$ezin_sys['db']['host'].':'.$ezin_sys['db']['port'].'/'.$ezin_sys['db']['name'];

$ezin_auth_options = array( /* {{{ */
		'dsn'      => $ezin_sys['db']['dsn'],
		'timeout'  => 1800, /* default value, will be overwritten
							  after configuration will be loaded from DB */
		'expired'  => 0, /* turned off */

		'sessions' => array(
			'table'     => $ezin_sys['db']['tables']['sessions'],
			'prefix'    => 'session_',
			'info_cols' => array('*')),
		'users' => array(
			'table'     => $ezin_sys['db']['tables']['users'],
			'prefix'    => '',
			'info_cols' => array('*'),
			'cols'      => array(
				'username' => 'username',
				'password' => 'password',
				'group_id' => 'role_id')),
		'groups' => array(
			'table'     => $ezin_sys['db']['tables']['roles'],
			'prefix'    => 'role_',
			'info_cols' => array('*'),
			'cols'      => array('id' => 'id'))
		); /* }}} */

$ezin_auth = false; // must be here! IMPORTANT!
$ezin_USER = false;

/*
 * CGI variables
 */

$ezin_cgi = array( /* {{{ */
		'query_string' => explode('&', $HTTP_SERVER_VARS['QUERY_STRING']),
		/* Input method. Possibilities:
		   index, section, article, message, admin, feedback */
		'input'        => 'index',
		/* Output method. Possibilities:
		   section, article, article_print,
		   message, message_full_list, message_selected_list,
		   feedback, feedback_thanks,
		   admin, error, notfound */
		'output'       => 'section',
		); /* }}} */

/*
 * Config load from database
 */

function ezin_eval($evalcode) /* {{{ */
{
	return @eval($evalcode);
} /* }}} */

function ezin_get_config() /* {{{ */
{
	global $ezin_sys;
	global $ezin_db_handle;

	$query = 'SELECT a_key, type, value '
		.' FROM ' . $ezin_sys['db']['tables']['config_data'];

	$result = @mysql_query($query, $ezin_db_handle) 
		or ezin_db_error('ezin_get_config()');

	$array = array();
	while ($row = @mysql_fetch_array($result, MYSQL_ASSOC)) {
		if (isset($row['type']) && $row['type'] == 1) {
			$array[$row['a_key']] = ezin_eval($row['value']);
		} else {
			$array[$row['a_key']] = $row['value'];
		}
	}
	@mysql_free_result($result);

	return $array;
} /* }}} */

require_once 'db-core/db-core.inc.php';
ezin_check_db_handle();
$ezin_cfg = ezin_get_config();
$ezin_auth_options['timeout'] = $ezin_cfg['admin_session_timeout'];
$ezin_theme_directory = $ezin_sys['dir']['themes'].'/'.$ezin_cfg['theme'];
$ezin_theme_url       = $ezin_cfg['url'] . $ezin_theme_directory;
if (!empty($ezin_cfg['languages'])) {
	$ezin_cfg['languages'] = preg_split('|\s+|', $ezin_cfg['languages']);
	count($ezin_cfg['languages']) > 0 || $ezin_cfg['languages'] = '';
}
if (intval(@$ezin_cfg['debug']) == 0) {
	error_reporting(E_ALL & (~ E_NOTICE));
}

/*
 * Mandatory HTTP host check
 */

@list($ezin_redirect_host, $ezin_redirect_path) = @explode('/', $ezin_cfg['http_host_redirect'], 2);
if (strlen($ezin_redirect_host) > 0 && strlen($_SERVER['HTTP_HOST']) > 0
		&& $ezin_redirect_host != $_SERVER['HTTP_HOST']) {
	$ezin_http_host_exclude_ar = preg_split('|\s+|', $ezin_cfg['http_host_exclude']);
	if (! in_array(strtolower($_SERVER['HTTP_HOST']), $ezin_http_host_exclude_ar)) {
		$url  = 'http://'.$ezin_redirect_host.'/'.$ezin_redirect_path;
		$url .= Platon::str_replace_prefix(
				Platon::append_slash($ezin_cfg['url']), '', $_SERVER['REQUEST_URI']);
		header('Location: '.$url);
		exit;
	}
}

/*
 * Redirect test
 */

Platon::redirect_test(basename(__FILE__), $ezin_cfg['url']);

/* Modeline for ViM {{{
 * vim: set ts=4:
 * vim600: fdm=marker fdl=0 fdc=0:
 * }}} */

?>
