<?php

/*
 * phpMyEzin - e-zin content management system
 *
 * db-core.inc.php - DB handle and DB error manipulation interface
 * ____________________________________________________________
 *
 * Developed by Ondrej Jombik <nepto@platon.sk>
 * Copyright (c) 2001-2003 Platon SDG, http://platon.sk/
 * All rights reserved.
 *
 * See README file for more information about this software.
 * See COPYING file for license information.
 *
 * Download the latest version from
 * http://platon.sk/projects/phpMyEzin/
 */

/* $Platon: $ */

/* MAINTAINANCE: This file is maintained in phpMyEzin project and distributed
   across the particular projects accordingly. */

/*
 * phpMyEzin global variabiles
 */

global $ezin_db_handle;
$ezin_db_handle = 0;

/*
 * ezin_db_error()
 *
 * Database error handling function
 */

function ezin_db_error($fnc_name = '', $message = '') /* {{{ */
{
	if (strlen($message) <= 0) {
		$message = 'error during work with database server';
	}

	if (strlen($fnc_name) > 0) {
		$message = "$fnc_name: $message";
	}

	if (0) {
		die ('<b>phpMyEzin fatal failure</b>: ' . $message 
				. '<br>Please contact webmaster or system administrator'
				. ' of this page with this problem.<br>');
	} else {
		trigger_error($message, E_USER_ERROR);
	}

	return false;
} /* }}} */

/*
 * ezin_open_db_connection()
 *
 * Opens database connection.
 */

function ezin_open_db_connection() /* {{{ */
{
	global $ezin_sys;
	global $ezin_db_handle;

	$ezin_db_handle = @mysql_pconnect(
			$ezin_sys['db']['host'].':'.$ezin_sys['db']['port'], 
			$ezin_sys['db']['user'], $ezin_sys['db']['pass']);

	if ($ezin_db_handle == false)
		return false;

	if (@mysql_select_db($ezin_sys['db']['name'], $ezin_db_handle) == false)
		return false;

	return $ezin_db_handle;
} /* }}} */


/*
 * ezin_close_db_connection()
 *
 * Closes database connection.
 */

function ezin_close_db_connection() /* {{{ */
{
	global $ezin_db_handle;
	$ret = @mysql_close($ezin_db_handle);
	$ezin_db_handle = 0;
	return $ret; // true if OK, false if failed
} /* }}} */


/*
 * ezin_check_db_handle()
 *
 * Check if databse connection is still alive.
 */

function ezin_check_db_handle() /* {{{ */
{
	global $ezin_db_handle;

	if ($ezin_db_handle == 0) {
		ezin_open_db_connection() 
			or ezin_db_error('ezin_check_db_handle()', 'database server connection error');
	}
} /* }}} */

//}

?>
